/*****************************************************************************/
/*--[tramp.asm]---------------------------------------------------------------
 | Copyright (C) 2002 Dan A. Jackson 
 |
 | This file is part of the "clit" (Convert LIT) program. 
 |
 | Convert LIT is free software; you can redistribute it and/or modify
 | it under the terms of the GNU General Public License as published by
 | the Free Software Foundation; either version 2 of the License, or
 | (at your option) any later version.
 |
 | This program is distributed in the hope that it will be useful,
 | but WITHOUT ANY WARRANTY; without even the implied warranty of
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 | GNU General Public License for more details.
 |
 | You should have received a copy of the GNU General Public License
 | along with this program; if not, write to the Free Software
 | Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 | 
 | The GNU General Public License may also be available at the following
 | URL: http://www.gnu.org/licenses/gpl.html
*/


.386
.MODEL FLAT

.DATA
EXTERN  _trampoline_target:DWORD
EXTERN  _ret_addr:DWORD
EXTERN  _paramcount:DWORD
.CODE

PUBLIC _jumpgate
_jumpgate PROC
        CMP  _paramcount, 0
        JZ   none
        MOV  EAX, _paramcount
        SHL  EAX, 2
@@:
        PUSH ss:[esp+eax]
        DEC  _paramcount
        JNZ  @B        
none:
        push _ret_addr
        JMP [_TRAMPOLINE_TARGET]
_jumpgate ENDP
END
