/* ***********************************************************************
   *                                                                     *
   * gui.c : Contains supplementary functions that don't need to be in   *
   *       : the main source file.                                       *
   *                                                                     *
   *********************************************************************** */

#include <windows.h>
#include <commctrl.h>
#include <commdlg.h>
#include <winuser.h>
#include "cuntcont.h"
#include "cunterror.h"
#include "ui.h"
extern HINSTANCE gInst;
extern HICON appIcon;

 /*.----------------------------------------------------------------------
   | RegisterWinClass : 
   |                  : Fills the WNDCLASSEX struct and regs the class
   |______________________________________________________________________
 */ 
ATOM RegisterWinClass(WNDPROC TheProc, HINSTANCE hInst, LPCTSTR appname) {
HCURSOR appCursor;

    WNDCLASSEX wc;

    if(! (appIcon = LoadIcon(gInst, (LPCTSTR)RESID_APPIC)) ) {  /* Load our pretty icon */
        lMsg(LOADRESRCE, TRUE);
    }

    if(! (appCursor = LoadCursor(NULL, IDC_ARROW)) ) {              /* Use a default cursor for now */
        lMsg(LOADRESRCE, TRUE);
    }

    wc.cbSize = sizeof(WNDCLASSEX);
    wc.style = CS_BYTEALIGNCLIENT | CS_BYTEALIGNWINDOW | CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
    wc.lpfnWndProc = TheProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInst;
    wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1); 
    wc.lpszMenuName = NULL;
    wc.lpszClassName = appname;
    wc.hIcon = appIcon;
    wc.hCursor = appCursor;
    wc.hIconSm = appIcon;

    return RegisterClassEx(&wc);

} // RegisterWinClass

 /*.----------------------------------------------------------------------- 
   |GetFile : 
   |        : Opens a standards windows dialogbox with some preset
   |        : values. Right now, only allow one file to make life easier.
   |_______________________________________________________________________
 */ 
 int GetFile(HWND hwd, HINSTANCE hi, OPENFILENAME lpof, char *nbuff, char *fname) {

    wsprintf(nbuff, "*.lit\0");
    ZeroMemory(&lpof, sizeof(lpof));
    lpof.lStructSize = sizeof(lpof);
    lpof.hwndOwner = hwd;
    lpof.hInstance = hi;
    lpof.lpstrFilter = "Proprietary Encrypted Ebook Shit\0*.LIT\0Nothing To See\0*.fag\0Move Along\0*.*\0All Your Clit Are Belong To Us\0*.twat\0";
    lpof.nFilterIndex = 0;
    lpof.lpstrFile = nbuff;
    lpof.nMaxFile = MAXPATHLEN;
    lpof.lpstrFileTitle = fname;
    lpof.nMaxFileTitle = MAXFILENLEN;
    lpof.lpstrTitle = "Help Bill with finding something what to shove into a cunt ...";
    lpof.lpstrDefExt = "LIT";
    lpof.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_EXPLORER; 

 return GetOpenFileName(&lpof);
 } /* GetFile ENDP */

 /*.----------------------------------------------------------------------
   |CreateClitBar : 
   |              : Creates a holder for our soccer mom buttons.
   |______________________________________________________________________
 */
HWND CreateClitBar(HWND hParent, HINSTANCE hI) {

 HWND hwndTB;
 TBBUTTON tbb[NUMBUTT];
 TBBUTTON blk;
 INITCOMMONCONTROLSEX icex;
 int x, y;
 char *bstrings[6] = {"Open", "Inscribe", "Convert", "Extract", "Options", "About\0\0"};

    /* Ensure that the common control DLL is loaded. */
    icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
    icex.dwICC  = ICC_BAR_CLASSES;
    InitCommonControlsEx(&icex);


    /* Zero memory so we don't have to explicitly null what we don't set. */
    ZeroMemory(tbb, sizeof(tbb)); 
    ZeroMemory(&blk, sizeof(blk)); 

    /* Fill the button structures */
    for (x = 0; x < NUMBUTT; x++) {   
        tbb[x].iBitmap = x;
        tbb[x].idCommand = (OPENCLIT + x );
        tbb[x].fsState = TBSTATE_ENABLED;
        tbb[x].fsStyle = TBSTYLE_BUTTON;
    }

    /* Create the toolbar. */
    hwndTB = CreateToolbarEx(hParent, WS_VISIBLE | TBSTYLE_FLAT | CCS_NODIVIDER,
    TOOLBAR_ID, 3, NULL, 
    (UINT)(LoadImage(hI, MAKEINTRESOURCE(RESID_TOOLBMP), IMAGE_BITMAP, (48 * NUMBUTT), 48, LR_LOADTRANSPARENT | LR_LOADMAP3DCOLORS)),
    (LPCTBBUTTON)&tbb, NUMBUTT, 48, 48, 48, 48,(UINT) sizeof(TBBUTTON)); 
  
    /* Send the TB_BUTTONSTRUCTSIZE message, which is required for backward compatibility.  */
    SendMessage(hwndTB, TB_BUTTONSTRUCTSIZE, (WPARAM) sizeof(TBBUTTON), 0);

    if (!hwndTB) {
        lMsg(BUTTCREATE, TRUE);
    }

    /* Major kludge: Create a blank button, and insert it for spacing */
    blk.iBitmap = -1;
    blk.fsState = TBSTATE_INDETERMINATE;

    for (x = 1; x < (NUMBUTT + 5); x++) {
        if ( (x == 1) || (x > 4 && x < 6) ) { 
                SendMessage(hwndTB, TB_INSERTBUTTON, (WPARAM)x, (LPARAM)(LPTBBUTTON)&blk);
        } else if ( x == 8  ) {
                SendMessage(hwndTB, TB_INSERTBUTTON, (WPARAM)x - 1, (LPARAM)(LPTBBUTTON)&blk);
        }

    }

    SendMessage(hwndTB, TB_AUTOSIZE, 0, 0);
    ShowWindow(hwndTB, SW_SHOW);

   return hwndTB; /* Handle, needed later if there's a WM_SYSCOLORCHANGE */

  } /* CreateClitBar ENDP */

 /*.----------------------------------------------------------------------
   |CreateListDisplay :
   |                  : Creates the list control for displaying LIT file info.
   |______________________________________________________________________
 */
void CreateListDisplay(HWND hParent) {
HWND hList = NULL;
LV_COLUMN lvProperty, lvValue;

    hList = CreateWindowEx(WS_EX_CLIENTEDGE, WC_LISTVIEW, "", 
    LVS_REPORT | WS_DISABLED | WS_CHILD | WS_VSCROLL | WS_VISIBLE,
                        7, 170, 500, 125, hParent, NULL, gInst, 0);
    if (! hList) {
        lMsg(LISTBOXSHW, TRUE);
    }

    lvProperty.mask =  LVCF_TEXT | LVCF_WIDTH;
    lvProperty.pszText = "Property\0";
    lvProperty.cx = 125;

    lvValue.mask =  LVCF_TEXT | LVCF_WIDTH;
    lvValue.pszText = "Value\0";
    lvValue.cx = 370;

    ListView_InsertColumn(hList, 0, &lvProperty);
    ListView_InsertColumn(hList, 1, &lvValue);

} /* CreateListBox ENDP */

/* .----------------------------------------------------------------------
   | CreateStatics :
   |               : Called to create the static controls.
   |______________________________________________________________________
 */
void CreateStatics(HWND hParent, HWND *gh, int *cH) {

char *labels[] = {"LIT to Process:", "LIT Header Infomation:", "LIT Inscription:", ""};
typedef struct scrnspos {
    UINT h;
    UINT v;
    UINT x;
    UINT y;
    } scrnp; /* Screen Info */
scrnp sp[4] = { {7, 80, 100, 15}, {7, 150, 200, 15}, {7, 300, 200, 15}, {7, 110, 550, 15} };  
int lp = 0;

    for (lp = 0; lp < 4; lp++) {
        gh[*cH] = CreateWindowEx(0, "STATIC", labels[lp], SS_LEFTNOWORDWRAP | WS_CHILD | WS_VISIBLE,
        sp[lp].h, sp[lp].v, sp[lp].x, sp[lp].y, hParent, NULL, gInst, 0);
        if (! gh[*cH]) {
            lMsg(LISTBOXSHW, TRUE);
        }
        (*cH)++;
    }


} /* CreateStatics ENDP */

/* .----------------------------------------------------------------------
   | CreateEdits :
   |               : Called to create input controls.
   |______________________________________________________________________
 */
void CreateEdits(HWND hParent, HWND *gh, int *cH) {

    gh[*cH] = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", 
                         WS_DISABLED | WS_VSCROLL | WS_CHILD | WS_VISIBLE | ES_AUTOVSCROLL | ES_LEFT 
                        | ES_WANTRETURN | ES_MULTILINE, 7, 320, 500, 45, hParent, NULL, gInst, 0);
    if (! gh[*cH]) 
        goto fail;

    (*cH)++;
    gh[*cH] = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | ES_LEFT,
                         110, 80, 360, 20, hParent, NULL, gInst, 0);

    if (! gh[*cH])
        goto fail;
    (*cH)++;

return;

fail:
    lMsg(EDITCREATE, TRUE); 

} /* CreateEdits ENDP */
